build:
  extends:
    - .kaniko-build
  script:
    - build_image

# Build with Kaniko, adding a stable tag to master builds
.build_helpers: &build_helpers |
  build_image() {
    destination="--destination $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA"
    if [ "$CI_COMMIT_REF_NAME" = "master" ]; then
      destination="$destination --destination $CI_REGISTRY_IMAGE:stable"
    fi
    /kaniko/executor --context $CI_PROJECT_DIR --cache=true --dockerfile "$CI_PROJECT_DIR/Dockerfile" $destination
  }


# Use Kaniko for building container images
.kaniko-build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug-v0.17.1
    entrypoint: [""]
  before_script:
    - *build_helpers
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
